VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Assign more memory to Java"
   ClientHeight    =   2895
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8205
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2895
   ScaleWidth      =   8205
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdGo 
      Caption         =   "Assign more memory to Java"
      Height          =   615
      Left            =   2400
      TabIndex        =   2
      Top             =   1920
      Width           =   3495
   End
   Begin VB.Label lblInstalledMemory 
      Caption         =   "Installed memory"
      Height          =   855
      Left            =   240
      TabIndex        =   1
      Top             =   600
      Width           =   7815
   End
   Begin VB.Label lblWhoAmI 
      Caption         =   "This program will allocate more memory to your Java installation"
      Height          =   255
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   7695
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const CSIDL_APPDATA = &H1A
Const SHGFP_TYPE_CURRENT = 0

Const MEMORY_TO_ALLOCATE = 200  ' megabytes to allocate

' return codes
Const AJM_NO_PARAM = 0          ' there are no parameters
Const AJM_OTHER_PARAMS = -1     ' there are also other parameters
Const AJM_ERR_GET_FOLDER = -2   ' unable to get the name of the "Application data" folder
Const AJM_READ_ERROR = -3       ' error reading the preferences file
Const AJM_UNKNOWN_PARAM = -4    ' unable to decode the parameter value

Private Declare Function SHGetFolderPath Lib "shfolder.dll" Alias "SHGetFolderPathA" _
    (ByVal hwndOwner As Long, ByVal nFolder As Long, _
    ByVal hToken As Long, ByVal dwReserved As Long, _
    ByVal lpszPath As String) As Long

' name of the preferences file
Dim fileName As String

' stores the various java versions found in the properties file (used for V1.5)
Dim javaVersions(200) As String
Dim njavaVersions As Integer

Private Function GetAppDataFolder() As String
    Dim folder As String
    Dim r As Long
    
    folder = Space(259)
    
    r = SHGetFolderPath(Me.hWnd, CSIDL_APPDATA, 0, SHGFP_TYPE_CURRENT, folder)
    If r <> 0 Then
        GetAppDataFolder = ""
        Exit Function
    End If
    
    folder = Trim(folder)
    folder = Left(folder, Len(folder) - 1)
    If Right(folder, 1) <> "\" Then folder = folder & "\"
    GetAppDataFolder = folder

End Function

' returns the number of currently allocated megabytes or a symbolic value
Private Function ReadAllocatedMemory(fileName As String) As Long
    Dim s As String, params As String, i As Integer, a As Variant
    Dim nFile As Integer, sMem As String, retVal As Long, s2 As String
    Dim version As String, argsLine As Boolean
    
    njavaVersions = 0
    nFile = FreeFile
    
    Open fileName For Input As #nFile
    params = ""
    While Not EOF(nFile)
        Line Input #nFile, s
        
        ' V 1.4
        If Left(s, 22) = "javaplugin.jre.params=" Then
            params = Mid(s, 23)
        End If
        
        ' V 1.5
        If Left(s, 21) = "deployment.javapi.jre" Then
            ParseV15Line s, version, params, argsLine
            If argsLine And version <> "" Then
                StoreJavaVersion version
            End If
        End If
        
    Wend
    Close #nFile
    
    If params = "" Then
        ReadAllocatedMemory = AJM_NO_PARAM
        Exit Function
    End If
    If InStr(params, "-") <> InStrRev(params, "-") Then
        ReadAllocatedMemory = AJM_OTHER_PARAMS
        Exit Function
    End If
    If Left(params, 4) <> "-Xmx" Then
        ReadAllocatedMemory = AJM_OTHER_PARAMS
        Exit Function
    End If
    
    sMem = Mid(params, 5)
    sMem = Trim(sMem)
    If UCase(Right(sMem, 1)) = "M" Then
        ' megabytes
        retVal = Val(sMem)
    ElseIf UCase(Right(sMem, 1)) = "K" Then
        ' kilobytes
        retVal = Val(sMem) / 1024
    Else
        ' bytes
        retVal = Val(sMem) / (1024# * 1024)
    End If
        
    ReadAllocatedMemory = retVal
End Function

Private Sub cmdGo_Click()
    AllocateJavaMemory fileName, MEMORY_TO_ALLOCATE
    MsgInfo MSG_MEMORY_INCREASED
    Unload Me
End Sub

Private Sub Form_Load()
    Dim nMega As Long
    
    frmChooseLanguage.Show 1
    
    SetupMessages
    lblWhoAmI = Messages(SelectedLanguage, MSG_WHOAMI)
    cmdGo.Caption = Messages(SelectedLanguage, MSG_ASSIGN_MORE_MEMORY)
    Me.Caption = cmdGo.Caption
    
    fileName = GetAppDataFolder
    If fileName <> "" Then
        fileName = fileName & "Sun\Java\Deployment\deployment.properties"
    End If
    
    nMega = ReadAllocatedMemory(fileName)
    
    If nMega = AJM_OTHER_PARAMS Then
        Sciopa MSG_OTHER_PARAMS
    End If
    If nMega = AJM_ERR_GET_FOLDER Then
        Sciopa MSG_ERR_GET_FOLDER
    End If
    If nMega >= MEMORY_TO_ALLOCATE Then
        Sciopa MSG_MEMORY_ALREADY_ASSIGNED
    End If
    
    If nMega > 0 Then
        lblInstalledMemory = Messages(SelectedLanguage, MSG_ALLOCATED_MEMORY) & CStr(nMega)
    End If
    If nMega = AJM_NO_PARAM Then
        lblInstalledMemory = Messages(SelectedLanguage, MSG_DEFAULT_MEMORY)
    End If
    
End Sub

Private Sub AllocateJavaMemory(fileName As String, nMega As Long)
    Dim fileNameTemp As String, nFileIn As Integer, nFileOut As Integer
    Dim s As String, foundParameter As Boolean, fileNameBak As String, argsLine As Boolean
    Dim writeLine As Boolean, k As Integer, version As String, params As String
    
    ' creates a corrected copy of the file
    fileNameTemp = fileName & ".tmp"
    nFileIn = FreeFile
    Open fileName For Input As #nFileIn
    nFileOut = FreeFile
    Open fileNameTemp For Output As #nFileOut
    
    foundParameter = False
    While Not EOF(nFileIn)
        Line Input #nFileIn, s
        writeLine = True
        
        ' v 1.4
        If Left(s, 22) = "javaplugin.jre.params=" Then
            s = "javaplugin.jre.params=-Xmx" & CStr(nMega) & "M"
            foundParameter = True
        End If
        
        ' V 1.5
        If Left(s, 21) = "deployment.javapi.jre" Then
            ParseV15Line s, version, params, argsLine
            If argsLine Then
                writeLine = False
            End If
        End If
        
        ' do not copy args lines for v 1.5
        If writeLine Then Print #nFileOut, s
    Wend
    If Not foundParameter And njavaVersions = 0 Then
        ' adds a line for v1.4
        s = "javaplugin.jre.params=-Xmx" & CStr(nMega) & "M"
        Print #nFileOut, s
    End If
    For k = 0 To njavaVersions - 1
        ' writes the V1.5 args lines
        s = "deployment.javapi.jre." & javaVersions(k) & ".args=-Xmx" & CStr(nMega) & "M"
        Print #nFileOut, s
    Next
    
    Close #nFileIn
    Close #nFileOut
    
    ' renames files
    fileNameBak = fileName & ".bak"
    DeleteFile fileNameBak
    Name fileName As fileNameBak
    Name fileNameTemp As fileName
    
End Sub


Private Sub Sciopa(msgId As Integer)
    MsgBox Messages(SelectedLanguage, msgId), vbExclamation
    End
End Sub

Private Sub MsgInfo(msgId As Integer)
    MsgBox Messages(SelectedLanguage, msgId), vbInformation
End Sub

Private Sub DeleteFile(fileName As String)
    On Error Resume Next
    Kill fileName
End Sub

Private Sub ParseV15Line(line As String, version As String, params As String, argsLine As Boolean)
    ' parses a line for version 1.5 java plugin
    ' version is an output parameter and it contains the version number part of the string
    ' params is an output parameter and it contains the parameters currentry set for
    '   the java plugin, it this is the right line, otherwise ""
    ' argsLine is an output parameter: true if this is a line that specifies the args for the plugin
    Dim a As Variant, s As String
    
    argsLine = False
    
    a = Split(line, ".")
    version = a(3) & "." & a(4) & "." & a(5)
    
    params = ""
    a = Split(line, "=")
    s = Right(a(0), 5)
    If s = ".args" Then
        params = a(1)
        argsLine = True
    End If

End Sub


Private Sub StoreJavaVersion(version As String)
    Dim k As Integer, found As Boolean
    
    found = False
    For k = 0 To njavaVersions - 1
        If javaVersions(k) = version Then
            found = True
        End If
    Next
    If Not found Then
        javaVersions(njavaVersions) = version
        njavaVersions = njavaVersions + 1
    End If

End Sub

