Attribute VB_Name = "modMessages"
Option Explicit

' number of supported languages
Const N_LANG = 3
Const DE = 0
Const EN = 1        ' language index
Const IT = 2

Public Const MSG_WHOAMI = 0
Public Const MSG_DEFAULT_MEMORY = 1
Public Const MSG_ALLOCATED_MEMORY = 2
Public Const MSG_OTHER_PARAMS = 3
Public Const MSG_ERR_GET_FOLDER = 4
Public Const MSG_MEMORY_INCREASED = 5
Public Const MSG_ASSIGN_MORE_MEMORY = 6
Public Const MSG_MEMORY_ALREADY_ASSIGNED = 7

Const N_MESSAGES = 10

' contains all the localized messages
Global Messages(N_LANG, N_MESSAGES) As String

' language selected by the user
Global SelectedLanguage As Integer

Public Sub SetupMessages()

    Messages(EN, MSG_WHOAMI) = "This program will allocate more memory to your Java installation"
    Messages(EN, MSG_DEFAULT_MEMORY) = "Java is currently allocating its default amount of memory"
    Messages(EN, MSG_ALLOCATED_MEMORY) = "Megabytes of memory currently allocated to Java: "
    Messages(EN, MSG_OTHER_PARAMS) = "This program has detected other parameters in the Java plugin configuration and it cannot handle this situation. This program cannot change the Java memory allocation."
    Messages(EN, MSG_ERR_GET_FOLDER) = "Unable to locate the application data folder. It is not possible to change the Java memory allocation."
    Messages(EN, MSG_MEMORY_INCREASED) = "This program has succesfully allocated more memory to your Java installation. Now you must close your browser (for example Internet Explorer or Firefox) and open it again."
    Messages(EN, MSG_ASSIGN_MORE_MEMORY) = "Assign more memory to Java"
    Messages(EN, MSG_MEMORY_ALREADY_ASSIGNED) = "A large amount of memory has already been assigned to your Java installation. You don't need to execute this program."

    Messages(IT, MSG_WHOAMI) = "Questo programma render disponibile pi memoria alla vostra installazione di Java"
    Messages(IT, MSG_DEFAULT_MEMORY) = "Al momento Java ha a disposizione la quantit predefinita di memoria"
    Messages(IT, MSG_ALLOCATED_MEMORY) = "Megabytes di memoria attualmente disponibili per Java: "
    Messages(IT, MSG_OTHER_PARAMS) = "Questo programma ha individuato altri parametri nella configurazione del plugin Java e non pu gestire questa situazione. Questo programma non  in grado di cambiare la memoria disponibile per Java."
    Messages(IT, MSG_ERR_GET_FOLDER) = "Impossibile individuare la cartella ""Dati Applicazioni"". Questo programma non  in grado di cambiare la memoria disponibile per Java."
    Messages(IT, MSG_MEMORY_INCREASED) = "Questo programma ha reso disponibile una maggiore quantit di memoria per la vostra installazione di Java. Adesso  necessario chiudere il browser (ad esempio Internet Explorer o Firefox) ed aprirlo di nuovo."
    Messages(IT, MSG_ASSIGN_MORE_MEMORY) = "Assegna pi memoria a Java"
    Messages(IT, MSG_MEMORY_ALREADY_ASSIGNED) = "Una grande quantit di memoria  gi stata assegnata alla vostra installazione di Java. Non  necessario eseguire questo programma."

    Messages(DE, MSG_WHOAMI) = "Dieses Programm wird ihrer Java Anwendung mehr Hauptspeicher zuteilen."
    Messages(DE, MSG_DEFAULT_MEMORY) = "Java steht zur Zeit ein vordefinierter Umfang an Hauptspeicher zur Verfgung."
    Messages(DE, MSG_ALLOCATED_MEMORY) = "Zur Verfgung stehender Hauptspeicher fr Java in Megabyte: "
    Messages(DE, MSG_OTHER_PARAMS) = "Diese Programm hat zustzliche Parameter in der Konfiguration des Java Plugin festgestellt und kann diese Parameter nicht verwalten. Das Programm kann den Umfang des fr Java zur Verfgung stehenden Hauptspeicher nicht verndern."
    Messages(DE, MSG_ERR_GET_FOLDER) = "Das Verzeichnis der Anwendung kann nicht gefunden werden. Das Programm kann den Umfang des fr Java zur Verfgung stehenden Hauptspeichers nicht verndern."
    Messages(DE, MSG_MEMORY_INCREASED) = "Das Programm hat ihrer Java Installation mehr Hauptspeicher zur Verfgung gestellt. Bitte schliessen Sie ihren Browser (Internet Explorer oder Firefox) und rufen Sie den Browser erneut auf."
    Messages(DE, MSG_ASSIGN_MORE_MEMORY) = "Mehr Hauptspeicher an Java vergeben"
    Messages(DE, MSG_MEMORY_ALREADY_ASSIGNED) = "Es wurde bereits ein groer Bereich des Hauptspeichers fr ihre Java Installation zur Verfgung gestellt. Das Programm muss daher nicht mehr ausgefhrt werden."

End Sub

